diff --git a/tests/kms_rotation_crc.c b/tests/kms_rotation_crc.c
index 7f09df3..2b2062b 100644
--- a/tests/kms_rotation_crc.c
+++ b/tests/kms_rotation_crc.c
@@ -34,8 +34,10 @@ typedef struct {
 	igt_display_t display;
 	struct igt_fb fb;
 	struct igt_fb fb_cursor;
+	struct igt_fb fb_full;
 	igt_crc_t ref_crc;
 	igt_pipe_crc_t *pipe_crc;
+	igt_rotation_t rotation;
 } data_t;
 
 static void
@@ -63,18 +65,46 @@ paint_squares(data_t *data, struct igt_fb *fb, drmModeModeInfo *mode,
 		w = mode->hdisplay;
 		h = mode->vdisplay;
 
-		cr = igt_get_cairo_ctx(data->gfx_fd, &data->fb);
+		cr = igt_get_cairo_ctx(data->gfx_fd, fb);
 
 		if (rotation == IGT_ROTATION_180) {
 			cairo_translate(cr, w, h);
 			cairo_rotate(cr, M_PI);
 		}
 
-		/* Paint with 4 squares of Red, Green, White, Blue Clockwise */
-		igt_paint_color(cr, 0, 0, w / 2, h / 2, 1.0, 0.0, 0.0);
-		igt_paint_color(cr, w / 2, 0, w / 2, h / 2, 0.0, 1.0, 0.0);
-		igt_paint_color(cr, 0, h / 2, w / 2, h / 2, 0.0, 0.0, 1.0);
-		igt_paint_color(cr, w / 2, h / 2, w / 2, h / 2, 1.0, 1.0, 1.0);
+		/*
+		 * "rotation" is used for creating ref rotated fb and
+		 * "data->rotation" is used to determine the required size
+		 * while creating unrotated fb.
+		 */
+		if (rotation == IGT_ROTATION_90) {
+			/* Paint 4 squares with width == height in Blue, Red,
+			Green, White Clockwise order to look like 90 degree rotated*/
+			w = h = mode->vdisplay;
+			igt_paint_color(cr, 0, 0, w / 2, h / 2, 0.0, 0.0, 1.0);
+			igt_paint_color(cr, w / 2, 0, w / 2, h / 2, 1.0, 0.0, 0.0);
+			igt_paint_color(cr, 0, h / 2, w / 2, h / 2, 1.0, 1.0, 1.0);
+			igt_paint_color(cr, w / 2, h / 2, w / 2, h / 2, 0.0, 1.0, 0.0);
+
+		} else if (rotation == IGT_ROTATION_270) {
+			/* Paint 4 squares with width == height in Green, White,
+			Blue, Red Clockwise order to look like 270 degree rotated*/
+			w = h = mode->vdisplay;
+			igt_paint_color(cr, 0, 0, w / 2, h / 2, 0.0, 1.0, 0.0);
+			igt_paint_color(cr, w / 2, 0, w / 2, h / 2, 1.0, 1.0, 1.0);
+			igt_paint_color(cr, 0, h / 2, w / 2, h / 2, 1.0, 0.0, 0.0);
+			igt_paint_color(cr, w / 2, h / 2, w / 2, h / 2, 0.0, 0.0, 1.0);
+
+		} else {
+			if (data->rotation == IGT_ROTATION_90 ||
+				data->rotation == IGT_ROTATION_270)
+				w = h = mode->vdisplay;
+			/* Paint with 4 squares of Red, Green, White, Blue Clockwise */
+			igt_paint_color(cr, 0, 0, w / 2, h / 2, 1.0, 0.0, 0.0);
+			igt_paint_color(cr, w / 2, 0, w / 2, h / 2, 0.0, 1.0, 0.0);
+			igt_paint_color(cr, 0, h / 2, w / 2, h / 2, 0.0, 0.0, 1.0);
+			igt_paint_color(cr, w / 2, h / 2, w / 2, h / 2, 1.0, 1.0, 1.0);
+		}
 	}
 	cairo_destroy(cr);
 }
@@ -84,7 +114,12 @@ static void prepare_crtc(data_t *data, igt_output_t *output, enum pipe pipe,
 {
 	drmModeModeInfo *mode;
 	igt_display_t *display = &data->display;
-	int fb_id, fb_cursor_id;
+	int fb_id, fb_cursor_id, fb_full_id;
+	int w, h;
+	uint64_t tiling = LOCAL_DRM_FORMAT_MOD_NONE;
+	enum igt_commit_style commit = COMMIT_LEGACY;
+	int old_rotation;
+	igt_plane_t *primary;
 
 	igt_output_set_pipe(output, pipe);
 
@@ -93,18 +128,51 @@ static void prepare_crtc(data_t *data, igt_output_t *output, enum pipe pipe,
 	data->pipe_crc = igt_pipe_crc_new(pipe, INTEL_PIPE_CRC_SOURCE_AUTO);
 
 	mode = igt_output_get_mode(output);
+	w = mode->hdisplay;
+	h = mode->vdisplay;
+
+	fb_full_id = igt_create_fb(data->gfx_fd,
+			w, h,
+			DRM_FORMAT_XRGB8888,
+			tiling,
+			&data->fb_full);
+	igt_assert(fb_full_id);
+
+	/*
+	 * With igt_display_commit2 and COMMIT_UNIVERSAL, we call just the
+	 * setplane without a modeset. So, to be able to call
+	 * igt_display_commit and ultimately setcrtc to do the first modeset,
+	 * we create an fb covering the crtc and call commit
+	 */
+
+	old_rotation = data->rotation;
+	data->rotation = IGT_ROTATION_0;
+	primary = igt_output_get_plane(output, IGT_PLANE_PRIMARY);
+	paint_squares(data, &data->fb_full, mode, IGT_ROTATION_0, primary);
+	igt_plane_set_fb(primary, &data->fb_full);
+	igt_display_commit(display);
+	data->rotation = old_rotation;
+
+	/*
+	 * For 90/270, we will use create smaller fb so that the rotated
+	 * frame can fit in
+	 */
+	if (data->rotation == IGT_ROTATION_90 ||
+		data->rotation == IGT_ROTATION_270) {
+		tiling = LOCAL_I915_FORMAT_MOD_Y_TILED;
+		w = h =  mode->vdisplay;
+	}
 
 	fb_id = igt_create_fb(data->gfx_fd,
-			mode->hdisplay, mode->vdisplay,
+			w, h,
 			DRM_FORMAT_XRGB8888,
-			false, /* tiled */
+			tiling,
 			&data->fb);
 	igt_assert(fb_id);
-
 	fb_cursor_id = igt_create_fb(data->gfx_fd,
 				     128, 128,
 				     DRM_FORMAT_ARGB8888,
-				     false, /* tiled */
+				     LOCAL_DRM_FORMAT_MOD_NONE,
 				     &data->fb_cursor);
 	igt_assert(fb_cursor_id);
 
@@ -116,23 +184,29 @@ static void prepare_crtc(data_t *data, igt_output_t *output, enum pipe pipe,
 	 * plane enabled at the moment.
 	 */
 	if (!plane->is_primary) {
-		igt_plane_t *primary;
 
 		primary = igt_output_get_plane(output, IGT_PLANE_PRIMARY);
-		paint_squares(data, &data->fb, mode, IGT_ROTATION_180, primary);
+		paint_squares(data, &data->fb, mode, IGT_ROTATION_0, primary);
 		igt_plane_set_fb(primary, &data->fb);
+		igt_require(data->display.has_universal_planes);
+		commit = COMMIT_UNIVERSAL;
+		igt_display_commit2(display, commit);
 	}
 
 	if (plane->is_cursor) {
-		paint_squares(data, &data->fb_cursor, mode, IGT_ROTATION_180, plane);
+		paint_squares(data, &data->fb_cursor, mode, data->rotation, plane);
 		igt_plane_set_fb(plane, &data->fb_cursor);
 	} else {
-		paint_squares(data, &data->fb, mode, IGT_ROTATION_180, plane);
+		paint_squares(data, &data->fb, mode, data->rotation, plane);
 		igt_plane_set_fb(plane, &data->fb);
 	}
-	igt_display_commit(display);
-	igt_pipe_crc_collect_crc(data->pipe_crc, &data->ref_crc);
+	if (plane->is_primary || plane->is_cursor) {
+		igt_require(data->display.has_universal_planes);
+		commit = COMMIT_UNIVERSAL;
+	}
 
+	igt_display_commit2(display, commit);
+	igt_pipe_crc_collect_crc(data->pipe_crc, &data->ref_crc);
 	/*
 	 * Step 2: prepare the plane with an non-rotated fb let the hw
 	 * rotate it.
@@ -155,6 +229,7 @@ static void cleanup_crtc(data_t *data, igt_output_t *output, igt_plane_t *plane)
 
 	igt_remove_fb(data->gfx_fd, &data->fb);
 	igt_remove_fb(data->gfx_fd, &data->fb_cursor);
+	igt_remove_fb(data->gfx_fd, &data->fb_full);
 
 	/* XXX: see the note in prepare_crtc() */
 	if (!plane->is_primary) {
@@ -200,23 +275,26 @@ static void test_plane_rotation(data_t *data, enum igt_plane plane_type)
 			/* collect unrotated CRC */
 			igt_pipe_crc_collect_crc(data->pipe_crc, &crc_unrotated);
 
-			igt_plane_set_rotation(plane, IGT_ROTATION_180);
+			igt_plane_set_rotation(plane, data->rotation);
 			igt_display_commit2(display, commit);
 
 			igt_pipe_crc_collect_crc(data->pipe_crc, &crc_output);
 			igt_assert(igt_crc_equal(&data->ref_crc, &crc_output));
 
-			/* check the rotation state has been reset when the VT
-			 * mode is restored */
+			/*
+			 * check the rotation state has been reset when the VT
+			 * mode is restored
+			 */
 			kmstest_restore_vt_mode();
 			kmstest_set_vt_graphics_mode();
 			prepare_crtc(data, output, pipe, plane);
+
 			igt_pipe_crc_collect_crc(data->pipe_crc, &crc_output);
 			igt_assert(igt_crc_equal(&crc_unrotated, &crc_output));
 
-
 			valid_tests++;
 			cleanup_crtc(data, output, plane);
+			break;
 		}
 	}
 	igt_require_f(valid_tests, "no valid crtc/connector combinations found\n");
@@ -237,15 +315,40 @@ igt_main
 
 		igt_display_init(&data.display, data.gfx_fd);
 	}
-
-	igt_subtest_f("primary-rotation")
+	igt_subtest_f("primary-rotation") {
+		data.rotation = IGT_ROTATION_180;
 		test_plane_rotation(&data, IGT_PLANE_PRIMARY);
+	}
 
-	igt_subtest_f("sprite-rotation")
+	igt_subtest_f("sprite-rotation") {
+		data.rotation = IGT_ROTATION_180;
 		test_plane_rotation(&data, IGT_PLANE_2);
+	}
 
-	igt_subtest_f("cursor-rotation")
+	igt_subtest_f("cursor-rotation") {
+		data.rotation = IGT_ROTATION_180;
 		test_plane_rotation(&data, IGT_PLANE_CURSOR);
+	}
+
+	igt_subtest_f("primary-rotation-90") {
+		data.rotation = IGT_ROTATION_90;
+		test_plane_rotation(&data, IGT_PLANE_PRIMARY);
+	}
+
+	igt_subtest_f("primary-rotation-270") {
+		data.rotation = IGT_ROTATION_270;
+		test_plane_rotation(&data, IGT_PLANE_PRIMARY);
+	}
+
+	igt_subtest_f("sprite-rotation-90") {
+		data.rotation = IGT_ROTATION_90;
+		test_plane_rotation(&data, IGT_PLANE_2);
+	}
+
+	igt_subtest_f("sprite-rotation-270") {
+		data.rotation = IGT_ROTATION_270;
+		test_plane_rotation(&data, IGT_PLANE_2);
+	}
 
 	igt_fixture {
 		igt_display_fini(&data.display);